
Figure - Bug #117232
测试 Test-IT # 110867 (New): V1.0测试功能汇总

测试 Test-IT # 110895 (New): AF-V1.0功能测试-桌面

【AF】【EVT】【桌面】应用宝下载安装多个应用时，提示“软件安装包无响应”
2023-03-29 16:11 - 物联网测试组_CDTS  唐霞 

Status: CLOSED Start date: 2023-03-29

Priority: Normal Due date:

Assignee: 物联网测试组_CDTS  唐霞 % Done: 0%

Category: CD-FW Estimated time: 0.00 hour

Target version:

Need_Info: TEST Found Version: FlatBuild_HH_MCE_FSE.M.R.user.01.00.0086.C102(X102)

Resolution: -- Degrated: --

Severity: Normal Verified Version:

Reproducibility: Frequently Fixed Version:

Test Type: Release Test Root cause:

Description

【前提条件】

系统存储空间还剩余10G以内

【测试步骤】

打开应用宝，同时下载安装多个应用（开启自动安装）

【预期结果】

选择下载的应用都能被正确安装，存储空间不足的情况下提示存储空间不足

【测试结果】

概率出现，提示“软件安装包无响应”

History

#1 - 2023-03-30 14:08 - CD FW 曹覃刚

- Status changed from New to ASSIGNED

- Assignee changed from CD FW 曹覃刚 to CD FW王武军

#2 - 2023-03-31 15:02 - CD FW王武军

【】当前状态

1、日志分析

anr发生点

03-28 20:20:09.880 I/WindowManager( 1543): ANR in com.android.packageinstaller/com.android.packageinstaller.PackageInstallerActivity. Reason:1c75467

com.android.packageinstaller/com.android.packageinstaller.PackageInstallerActivity (server) is not responding. Waited 5000ms for FocusEvent(hasFocus=false)

03-28 20:20:17.066 E/ActivityManager( 1543): ANR in com.android.packageinstaller (com.android.packageinstaller/.PackageInstallerActivity)

anr发生前com.tencent.pangu通过系统的辅助功能用系统的安装工具packageinstaller进行作业。

03-28 20:19:41.673 I/ActivityTaskManager( 1543): START u0 {act=android.intent.action.VIEW

dat=content://com.tencent.pangu.fileprovider/external_path/Android/data/com.tencent.android.qqdownloader/files/tassistant/apk/com.android.bankabc_90.ap

k typ=application/vnd.android.package-archive flg=0x10000003 cmp=com.android.packageinstaller/.InstallStart} from uid 10135

03-28 20:19:41.696 I/ActivityTaskManager( 1543): START u0 {act=android.intent.action.VIEW

dat=content://com.tencent.pangu.fileprovider/external_path/Android/data/com.tencent.android.qqdownloader/files/tassistant/apk/com.android.bankabc_90.ap

k typ=application/vnd.android.package-archive flg=0x2000001 cmp=com.android.packageinstaller/.InstallStaging (has extras)} from uid 10035

03-28 20:19:41.826 I/ActivityTaskManager( 1543): START u0 {act=android.intent.action.VIEW

dat=file:///data/user_de/0/com.android.packageinstaller/no_backup/package7100702191339310151.apk flg=0x2010001

cmp=com.android.packageinstaller/.DeleteStagedFileOnResult (has extras)} from uid 10035
03-28 20:19:41.980 I/ActivityTaskManager( 1543): START u0 {act=android.intent.action.VIEW

dat=file:///data/user_de/0/com.android.packageinstaller/no_backup/package7100702191339310151.apk flg=0x10000

cmp=com.android.packageinstaller/.PackageInstallerActivity (has extras)} from uid 10035

03-28 20:19:42.263 I/ActivityTaskManager( 1543): START u0

{dat=file:///data/user_de/0/com.android.packageinstaller/no_backup/package7100702191339310151.apk flg=0x2000000

cmp=com.android.packageinstaller/.InstallInstalling (has extras)} from uid 10035

03-28 20:19:43.938 I/ActivityTaskManager( 1543): START u0

{dat=file:///data/user_de/0/com.android.packageinstaller/no_backup/package7100702191339310151.apk flg=0x2000000

cmp=com.android.packageinstaller/.InstallSuccess (has extras)} from uid 10035

03-28 20:19:47.261 I/ActivityTaskManager( 1543): START u0 {act=android.intent.action.VIEW

dat=content://com.tencent.pangu.fileprovider/external_path/Android/data/com.tencent.android.qqdownloader/files/tassistant/apk/com.tencent.lolm_654564.ap

k typ=application/vnd.android.package-archive flg=0x10000003 cmp=com.android.packageinstaller/.InstallStart} from uid 10135

03-28 20:19:47.281 I/ActivityTaskManager( 1543): START u0 {act=android.intent.action.VIEW

dat=content://com.tencent.pangu.fileprovider/external_path/Android/data/com.tencent.android.qqdownloader/files/tassistant/apk/com.tencent.lolm_654564.ap

k typ=application/vnd.android.package-archive flg=0x2000001 cmp=com.android.packageinstaller/.InstallStaging (has extras)} from uid 10035

03-28 20:19:50.867 I/ActivityTaskManager( 1543): START u0 {act=android.intent.action.VIEW

dat=file:///data/user_de/0/com.android.packageinstaller/no_backup/package8167516425871685319.apk flg=0x2010001

cmp=com.android.packageinstaller/.DeleteStagedFileOnResult (has extras)} from uid 10035

03-28 20:19:50.894 I/ActivityTaskManager( 1543): START u0 {act=android.intent.action.VIEW

dat=file:///data/user_de/0/com.android.packageinstaller/no_backup/package8167516425871685319.apk flg=0x10000

cmp=com.android.packageinstaller/.PackageInstallerActivity (has extras)} from uid 10035

03-28 20:19:52.039 I/ActivityTaskManager( 1543): START u0

{dat=file:///data/user_de/0/com.android.packageinstaller/no_backup/package8167516425871685319.apk flg=0x2000000

cmp=com.android.packageinstaller/.InstallInstalling (has extras)} from uid 10035

03-28 20:19:58.589 I/ActivityTaskManager( 1543): START u0 {act=android.intent.action.VIEW

dat=content://com.tencent.pangu.fileprovider/external_path/Android/data/com.tencent.android.qqdownloader/files/tassistant/apk/com.baidu.netdisk_1927.apk

typ=application/vnd.android.package-archive flg=0x10000003 cmp=com.android.packageinstaller/.InstallStart} from uid 10135

03-28 20:19:58.608 I/ActivityTaskManager( 1543): START u0 {act=android.intent.action.VIEW

dat=content://com.tencent.pangu.fileprovider/external_path/Android/data/com.tencent.android.qqdownloader/files/tassistant/apk/com.baidu.netdisk_1927.apk

typ=application/vnd.android.package-archive flg=0x2000001 cmp=com.android.packageinstaller/.InstallStaging (has extras)} from uid 10035

03-28 20:19:59.738 I/ActivityTaskManager( 1543): START u0 {act=android.intent.action.VIEW

dat=content://com.tencent.pangu.fileprovider/external_path/Android/data/com.tencent.android.qqdownloader/files/tassistant/apk/com.tencent.mtt_13760500.a

pk typ=application/vnd.android.package-archive flg=0x10000003 cmp=com.android.packageinstaller/.InstallStart} from uid 10135

03-28 20:19:59.755 I/ActivityTaskManager( 1543): START u0 {act=android.intent.action.VIEW

dat=content://com.tencent.pangu.fileprovider/external_path/Android/data/com.tencent.android.qqdownloader/files/tassistant/apk/com.tencent.mtt_13760500.a

pk typ=application/vnd.android.package-archive flg=0x2000001 cmp=com.android.packageinstaller/.InstallStaging (has extras)} from uid 10035

03-28 20:20:04.353 I/ActivityTaskManager( 1543): START u0 {act=android.intent.action.VIEW

dat=file:///data/user_de/0/com.android.packageinstaller/no_backup/package8087528769170272137.apk flg=0x2010001

cmp=com.android.packageinstaller/.DeleteStagedFileOnResult (has extras)} from uid 10035

03-28 20:20:04.379 I/ActivityTaskManager( 1543): START u0 {act=android.intent.action.VIEW

dat=file:///data/user_de/0/com.android.packageinstaller/no_backup/package8087528769170272137.apk flg=0x10000

cmp=com.android.packageinstaller/.PackageInstallerActivity (has extras)} from uid 10035

03-28 20:20:04.837 I/ActivityTaskManager( 1543): START u0

{dat=file:///data/user_de/0/com.android.packageinstaller/no_backup/package8087528769170272137.apk flg=0x2000000

cmp=com.android.packageinstaller/.InstallInstalling (has extras)} from uid 10035

anr前cpu的使用情况

03-28 20:20:17.066 E/ActivityManager( 1543): CPU usage from 0ms to 7115ms later (2023-03-28 20:20:09.923 to 2023-03-28 20:20:17.039):

03-28 20:20:17.066 E/ActivityManager( 1543):   111% 1543/system_server: 87% user + 24% kernel / faults: 60101 minor 7 major

03-28 20:20:17.066 E/ActivityManager( 1543):   37% 3100/com.tencent.android.qqdownloader: 22% user + 14% kernel / faults: 58895 minor 2 major

03-28 20:20:17.066 E/ActivityManager( 1543):   24% 4120/com.android.packageinstaller: 15% user + 9.5% kernel / faults: 7923 minor 12 major

03-28 20:20:17.066 E/ActivityManager( 1543):   22% 845/vendor.qti.hardware.display.composer-service: 14% user + 8.4% kernel / faults: 505 minor 8 major

03-28 20:20:17.066 E/ActivityManager( 1543):   16% 931/surfaceflinger: 13% user + 3.7% kernel / faults: 1469 minor
03-28 20:20:17.066 E/ActivityManager( 1543):   9.6% 3438/com.tencent.android.qqdownloader:daemon: 7.3% user + 2.3% kernel / faults: 12628 minor

03-28 20:20:17.066 E/ActivityManager( 1543):   8.1% 3486/dp_rx_thread_0: 0% user + 8.1% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):   5.2% 96/kswapd-1:0: 0% user + 5.2% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):   4.3% 2943/com.hht.lebocast: 3.2% user + 1.1% kernel / faults: 1912 minor 9 major

03-28 20:20:17.066 E/ActivityManager( 1543):   3.6% 3097/com.qualcomm.qti.workloadclassifier: 2.9% user + 0.7% kernel / faults: 7086 minor

03-28 20:20:17.066 E/ActivityManager( 1543):   2.5% 347/kworker/u16:15-kverityd: 0% user + 2.5% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):   2.3% 504/logd: 0.7% user + 1.6% kernel / faults: 69 minor

03-28 20:20:17.066 E/ActivityManager( 1543):   2.3% 2600/com.android.launcher3: 1.6% user + 0.7% kernel / faults: 2415 minor

03-28 20:20:17.066 E/ActivityManager( 1543):   2.2% 2045/com.android.systemui: 1.6% user + 0.5% kernel / faults: 1526 minor

03-28 20:20:17.066 E/ActivityManager( 1543):   1.8% 279/kworker/u16:6-kverityd: 0% user + 1.8% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):   1.5% 754/crtc_commit:125: 0% user + 1.5% kernel

03-28 20:20:17.066 E/ActivityManager( 1543): CPU usage from 64ms to 423ms later (2023-03-28 20:20:09.987 to 2023-03-28 20:20:10.347):

03-28 20:20:17.066 E/ActivityManager( 1543):   445% 1543/system_server: 368% user + 76% kernel / faults: 9397 minor

03-28 20:20:17.066 E/ActivityManager( 1543):     96% 1571/HeapTaskDaemon: 89% user + 6.6% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):     83% 7316/pool-11-thread-: 66% user + 16% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):     79% 7315/pool-11-thread-: 63% user + 16% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):     79% 7317/pool-11-thread-: 73% user + 6.6% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):     76% 7314/pool-11-thread-: 66% user + 9.9% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):     29% 7321/AnrConsumer: 6.6% user + 23% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):   21% 845/vendor.qti.hardware.display.composer-service: 12% user + 9% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):     21% 1071/HwBinder:845_2: 12% user + 9% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):   25% 3100/com.tencent.android.qqdownloader: 11% user + 14% kernel / faults: 1829 minor

03-28 20:20:17.066 E/ActivityManager( 1543):     11% 7078/HallyDownload-S: 3.7% user + 7.4% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):     7.4% 3807/HalleyDownload-: 3.7% user + 3.7% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):     7.4% 7252/HallyDownload-D: 3.7% user + 3.7% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):     3.7% 5153/Cate_DefaultMas: 3.7% user + 0% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):   23% 3486/dp_rx_thread_0: 0% user + 23% kernel

03-28 20:20:17.066 E/ActivityManager( 1543):   13% 96/kswapd-1:0: 0% user + 13% kernel

可以看出system_server进程占用了cpu的大部分时间，而且存在多个线程池在syste_server中作业。

结合测试操作流程，从逻辑层面来看，因为应用宝使用系统的辅助功能，会在安装apk时，实现自动点击，自动安装的一些列操作，而这些操作都会

与system_server有交互，大部分操作是在system_server进程中完成，而且安装的应用又很多，会长时间的在system_server中通过packageinstaller进行作业，

在packageinstaller发生的输入事件会因为当前系统卡顿导致响应延时，发生ANR。

系统卡顿从下面的日志也可以看出，系统不停的在做GC，说明当前的内存使用告急，应用宝又不停的在下载安装应用，导致系统的整体性能出现瓶颈

03-28 20:19:44.132 I/system_server( 1543): Background concurrent copying GC freed 422861(19MB) AllocSpace objects, 73(7624KB) LOS objects, 42% free,

31MB/55MB, paused 63us,51us total 218.318ms

03-28 20:20:07.024 I/system_server( 1543): Background concurrent copying GC freed 70519(2591KB) AllocSpace objects, 15(10112KB) LOS objects, 35% free,

44MB/68MB, paused 51us,50us total 116.376ms

03-28 20:20:07.325 I/system_server( 1543): Background concurrent copying GC freed 88691(3386KB) AllocSpace objects, 20(10MB) LOS objects, 27% free,

64MB/88MB, paused 75us,56us total 130.814ms

03-28 20:20:08.056 I/system_server( 1543): Background concurrent copying GC freed 47504(3129KB) AllocSpace objects, 655(32MB) LOS objects, 25% free,

70MB/94MB, paused 63us,67us total 259.208ms

03-28 20:20:09.181 I/system_server( 1543): Background concurrent copying GC freed 59534(3564KB) AllocSpace objects, 642(30MB) LOS objects, 26% free,

66MB/90MB, paused 59us,69us total 221.307ms

2、综合来看

anr的发生是因为在应用宝中下载了很多的应用，进行静默安装，使用系统的辅助功能完成该流程，而这一系列的操作都会涉及与system_server交互，特

别是安装的逻辑

都是com.android.packageinstaller通过system_server完成，不停的下载以及不停的安装，导致系统整体性能下载，cpu使用过载，内存使用告急，这个时候

com.android.packageinstaller中发生了输入事件，就有很大概率发生处理超时，发生anr。
3、处理策略

下载安装apk的这个操作，如果系统当时的整体性能正常，cpu负载不高，内存使用正常，一般是不会发生anr的。

但是如果下载大量的应用，并且使用辅助功能进行安装操作，这种操作本身就会加速cpu和内存的使用，会降低当前系统的整体性能，如果这种操作反复

执行

或者当前系统已经存在降低的情况，那么发生anr的概率就会加大，而这种操作引发系统整体的性能降低发生anr，是没办法从系统层面进行处理的，

只能建议不要一次性下载安装太多的应用，分批次来完成该操作，将系统性能的整体消耗进行分散。

综述：该票不做特殊处理，维持现状。

#3 - 2023-04-12 21:09 - CD FW 曹覃刚

[当前情况]

下载安装apk的这个操作，如果系统当时的整体性能正常，cpu负载不高，内存使用正常，一般是不会发生anr的。

但是如果下载大量的应用，并且使用辅助功能进行安装操作，这种操作本身就会加速cpu和内存的使用，会降低当前系统的整体性能，如果这种操作

反复执行

或者当前系统已经存在降低的情况，那么发生anr的概率就会加大，而这种操作引发系统整体的性能降低发生anr，是没办法从系统层面进行处理的，

只能建议不要一次性下载安装太多的应用，分批次来完成该操作，将系统性能的整体消耗进行分散。

综述：该票不做特殊处理，维持现状。

需要确认下发生的场景，如果存储空间剩的较多，且仅同时安装几个应用时，就会发生的话，很难推不解

[下一步动作]

确认复现的条件

#4 - 2023-04-14 10:31 - CD FW王武军

【】信息确认

从目前与测试的沟通和问题的调查情况来看，

该问题的发生的必要条件是：

1）在应用宝中一次下载20+的应用；

2）开启应用宝中的“自动安装模式”；

而当前存储空间的大小与问题发生不是必要条件，只是在存储更小时，问题发生的概率会大一些

@测试同事

请帮忙明确下面几个信息：

1）该问题的发生概率是多少？比如在存储很多正常的情况下，发生的概率（？/10）;存储不是很多的时候，发生的概率（?/10）;

2）是否可以使用不同类型的应用市场软件进行对比测试，看是否发生该问题，如果发生请记录日志和anr等信息？比如：华为市场、小米市场等；

#5 - 2023-04-18 16:32 - 物联网测试组_CDTS  唐霞 

- File 418.7z added

- File 软件安装包无响应.jpg added

- File 418-33.txt added

和存储空间大小没有必然的关系，同时下载安装的应用越多越容易出现：今日出现2次 ，一次在存储空间已使用48%,一次85%

测试百度手机助手/华为应用市场/豌豆荚/应用宝，只有应用会出现这种情况，其他市场未出现这种情况
#6 - 2023-04-18 20:17 - CD FW 曹覃刚

- Status changed from ASSIGNED to NEED_INFO

- Assignee changed from CD FW王武军 to CDTS_TEST 王成

- Need_Info changed from -- to TEST

Hi 王成

当前问题

应用宝下载安装多个应用时，提示“软件安装包无响应”

问题发生场景

1.开启应用宝中的“自动安装模式”

2.在应用宝中一次下载20+的应用

3.同比测试过，其他应用市场，百度手机助手/华为应用市场/豌豆荚，均不存在问题

4.且满足上述情况下，问题也是概率发生

目前研发定位的原因为:应用宝中对于应用下载安装的不合理处理，导致系统整体性能下降，cpu使用过载，从而引发问题

根据上述问题发生场景以及原因分析

最合适的处理方式是在应用宝内部做优化，需要三方应用自身做适配

在系统侧，很难做优化。

因此，此问题我们想申请不做处理，请综合评估考虑，谢谢

#7 - 2023-05-17 11:19 - CDTS_TEST 王成

- Assignee changed from CDTS_TEST 王成 to CD TPM-王祥林

请评估是否不做处理

#8 - 2023-06-03 23:18 - CD TPM-王祥林

- Status changed from NEED_INFO to RESOLVED

- Assignee changed from CD TPM-王祥林 to CDTS_TEST 王成

应用宝的问题，不做处理。

#9 - 2023-06-06 22:11 - CDTS_TEST 王成

- Assignee changed from CDTS_TEST 王成 to 物联网测试组_CDTS  唐霞 

#10 - 2023-06-07 10:13 - 物联网测试组_CDTS  唐霞 

- Status changed from RESOLVED to VERIFIED

不处理，关闭问题单

#11 - 2023-06-07 10:18 - 物联网测试组_CDTS  唐霞 

- Status changed from VERIFIED to CLOSED
Files

329-1.txt 3.49 MB 2023-03-29 物联网测试组_CDTS  唐霞 

418.7z 2.06 MB 2023-04-18 物联网测试组_CDTS  唐霞 

软件安装包无响应.jpg 57.9 KB 2023-04-18 物联网测试组_CDTS  唐霞 

418-33.txt 5.26 MB 2023-04-18 物联网测试组_CDTS  唐霞 
